hdu 3887 Counting Offspring dfs序+树状数组

Counting Offspring

Time Limit: 15000/5000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)


Problem Description
You are given a tree, it’s root is p, and the node is numbered from 1 to n. Now define f(i) as the number of nodes whose number is less than i in all the succeeding nodes of node i. Now we need to calculate f(i) for any possible i.
 
Input
Multiple cases (no more than 10), for each case:
The first line contains two integers n (0<n<=10^5) and p, representing this tree has n nodes, its root is p.
Following n-1 lines, each line has two integers, representing an edge in this tree.
The input terminates with two zeros.
 
Output
For each test case, output n integer in one line representing f(1), f(2) … f(n), separated by a space.
 
Sample Input
15 7 7 10 7 1 7 9 7 3 7 4 10 14 14 2 14 13 9 11 9 6 6 5 6 8 3 15 3 12 0 0
 
Sample Output
0 0 0 0 0 1 6 0 3 1 0 0 0 2 0
 
Author
bnugong
 
Source
题意:给你一棵树,你需要求每个子树中序号比其小的个数;
思路:dfs序,处理出每个子树的序列,因为比其小才有贡献,所以从小到大处理即可,用树状数组维护一下;
#include<bits/stdc++.h>
using namespace std;
#define ll long long
#define pi (4*atan(1.0))
#define eps 1e-14
const int N=1e5+10,M=1e6+10,inf=1e9+10;
const ll INF=1e18+10,mod=2147493647;
int tree[N];
int lowbit(int x)
{
    return x&(-x);
}
void update(int x,int c)
{
    while(x<N)
    {
        tree[x]+=c;
        x+=lowbit(x);
    }
}
int getnum(int x)
{
    int sum=0;
    while(x)
    {
        sum+=tree[x];
        x-=lowbit(x);
    }
    return sum;
}
int query(int L,int R)
{
    return getnum(R)-getnum(L-1);
}
struct is
{
    int v,nex;
}edge[N<<1];
int head[N<<1],edg;
int in[N],out[N],tot;
int n,p;
void init()
{
    memset(tree,0,sizeof(tree));
    memset(head,-1,sizeof(head));
    edg=0;
    tot=0;
}
void add(int u,int v)
{
    edg++;
    edge[edg].v=v;
    edge[edg].nex=head[u];
    head[u]=edg;
}
void dfs(int u,int fa)
{
    in[u]=++tot;
    for(int i=head[u];i!=-1;i=edge[i].nex)
    {
        int v=edge[i].v;
        if(v==fa)continue;
        dfs(v,u);
    }
    out[u]=tot;
}
int main()
{
    while(~scanf("%d%d",&n,&p))
    {
        init();
        if(n==0&&p==0)break;
        for(int i=1;i<n;i++)
        {
            int u,v;
            scanf("%d%d",&u,&v);
            add(u,v);
            add(v,u);
        }
        dfs(p,-1);
        for(int i=1;i<=n;i++)
        {
            printf("%d%c",query(in[i],out[i]),((i==n)?'
':' '));
            update(in[i],1);
        }
    }
    return 0;
}
原文地址:https://www.cnblogs.com/jhz033/p/6134926.html